//import 'dart:async';
//
//import "package:angular/angular.dart";
//import 'package:ng_bootstrap/components/modal/modal.dart';
//import 'package:roadmap_planner_web_components/routes.dart';
//
//
//@Component(selector: "rm-modal",
//    templateUrl: "rm_modal.html",
//    styleUrls: ['rm_modal.css'],
//    directives: const [BsModalComponent])
//class RmModal {
//
//  RmModal();
//
//  @ViewChild('myModal') BsModalComponent modal;
//
//  String modalAction;
//
//  onModalClose(String _modalAction) {
//    modalAction = _modalAction;
//    print('modalAction: $modalAction');
//  }
//
//  handleSave() {
//    print('saving');
//    return 'SAVE';
//  }
//
//  handleCancel() {
//    print('cancelling');
//    return new Future.delayed(const Duration(seconds: 2), () => 'CANCEL');
//  }
//}

// Copyright (c) 2016, <your name>. All rights reserved. Use of this source code

// is governed by a BSD-style license that can be found in the LICENSE file.

import 'dart:async';
import 'dart:html';
import 'package:angular/angular.dart';

/// Shows a bootstrap modal dialog.
/// Set the body of the dialog by adding content to the modal tag:
///
///     <bs-modal>content here</bs-modal>
///
@Component(
    selector: 'rp-modal',
    templateUrl: 'rp_modal.html',
    styleUrls: ['rp_modal.css'],
    directives: const [coreDirectives])
class RpModal {

  List<BsModalButton> _buttons;

  RpModal();

  @ViewChild('backDrop') Element backDrop;
  @ViewChild('modalMain') Element modalMain;
  @ViewChild('contentRef', read: ViewContainerRef)
  ViewContainerRef contentRef;

  List<BsModalButton> get buttons => _buttons;

  bool loading = false;

  @Input('header') String header;

  @Input() void set buttons(List/* <BsModalButton | Map> */ buttons) {
    _buttons = buttons.map<BsModalButton>((button) =>
    button is Map
        ? new BsModalButton(
        button['label'],
        id: button['id'],
        cssClasses: button['cssClasses'] ?? 'btn-primary',
        onClick: button['onClick'])
        : button
    ).toList();
  }

//  final ComponentLoader _loader;

//  ComponentRef _component;
//
//  /// Adds a component to the modal
//  ///
//  /// Creates a modal with the reference [contentRef], if a [_component] already
//  /// exist it will be destroyed to avoid creating components
//  @Input()
//  set component(ComponentFactory component){
//    if(component!=null){
//      if(_component != null){
//        _component.destroy();
//      }
//      _component = _loader.loadNextToLocation(component, contentRef);
//    }
//  }
//
//  ComponentRef get componentRef => _component;

  /// Fires an event when the modal is closed. The argument indicated how it was closed.
  /// @type {EventEmitter<ModalResult>}
  @Output() Stream<String> get close => _closeCtrl.stream;

  final _closeCtrl = new StreamController<String>.broadcast();

  bool showModal = false;

  /// Shows the modal. There is no method for hiding. This is done using actions of the modal itself.
  void show() {
    modalMain.style.display = 'block';

    new Future.delayed(const Duration(milliseconds: 0), () {
      showModal = true;
      backDrop.classes.add('show');
      document.body.classes.add('modal-open');
    });
  }

  Future<bool> hide([BsModalButton button]) async {
    loading = true;
    _closeCtrl.add(await button?.onClick?.call());
    showModal = false;
    loading = false;
    document.body.classes.remove('modal-open');
    new Future.delayed(const Duration(milliseconds: 200), () {
      modalMain.style.display = 'none';
      backDrop.classes.remove('show');
    });

    return false;
  }
}

/// Simple class to save all the modal button variables
class BsModalButton {
  final String label;
  final String id;
  final String cssClasses;
  final Function/* () => Future<String> | String */ onClick;

  const BsModalButton(this.label, {this.id, this.cssClasses = 'btn-primary', this.onClick});
}